﻿/*
	DbFS.NET
    Copyright (C) 2016 SCAND Ltd, svg@scand.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

namespace dbfs
{
	using System;

	public enum ChangeType
	{
		UPDATE = 0,
		ADD = 1,
		DELETE = 2,
		COPY = 3,
		RENAME = 4,
		RENAMED = 5,
	}

	public abstract class BaseFileEntity
	{
		public abstract bool IsDirectory { get; }

		public int Id { get; protected set; }
		protected internal int RevisionID { get; protected set; }
		public string Name { get; protected set; }
		public string Path { get; protected set; }
		public DateTime Date { get; protected set; }
		public int CommitId { get; protected set; }
		public string UserName { get; protected set; }
		public ChangeType ChangeType { get; protected set; }

		/// <summary>RENAMED acts as DELETE</summary>
		public bool IsRemoved
		{
			get { return ChangeType == ChangeType.DELETE || ChangeType == ChangeType.RENAMED; }
		}
	}
}
